﻿Imports System.IO
Imports System.Text

Public Class FileReadWriter
   Private _Encoding As Encoding
   Private _Path As String

	''' <summary> count&lt;0 makes me read the whole file. Note! enc may change to the
	''' correct Encoding, according to the ByteOrderMarks</summary>
	Public Shared Function Read(ByVal path As String, ByVal charCount As Integer,
			Optional ByRef enc As Encoding = Nothing) As String
		If enc Is Nothing Then enc = Encoding.Default
		Using rd As New StreamReader(path, enc, True)
			Try
				Select Case charCount
					Case < 0 : Return rd.ReadToEnd
					Case 0 : Return ""
					Case Else
						Dim buf(charCount - 1) As Char
						charCount = rd.Read(buf, 0, charCount)
						Return New String(buf, 0, charCount)
				End Select
			Finally
				enc = rd.CurrentEncoding
			End Try
		End Using
	End Function

	Public Shared Function ChangeEncoding(ByVal path As String, ByVal enc As Encoding, _
         Optional ByVal defaultEncoding As Encoding = Nothing) As Boolean
      Using str As New FileStream(path, FileMode.Open, FileAccess.ReadWrite), _
            rd As New StreamReader(str, If(defaultEncoding, Encoding.Default), True)
         Dim content = rd.ReadToEnd
         Dim readEnc = rd.CurrentEncoding
         If readEnc.Equals(enc) Then Return False
         str.Position = 0
         Using wr As New StreamWriter(str, enc)
            wr.Write(content)
         End Using
      End Using
      Return True
   End Function

   Public Function Read(ByVal path As String, Optional ByVal defaultEncoding As Encoding = Nothing) As String
      _Path = path
      _Encoding = defaultEncoding
      Return Read(path, -1, _Encoding)
   End Function

   Public Sub Write(ByVal content As String, Optional ByVal target As String = "")
      If target = "" Then target = _Path
      File.WriteAllText(target, content, _Encoding)
   End Sub

End Class
